<template>
  <div class="App" id="app">
    <div class="game">
      <div class="demo-scene">
        <div class="messages">
          <p>{{ status }}</p>
          <p>{{ message }}</p>
          <button v-show="toggleJoinButton" @click="join">Join</button>
          <button v-show="toggleReadyButton" @click="ready">Ready</button>
          <button v-show="toggleRematchButton" @click="rematch">Rematch</button>
          <img v-show="toggleExclamationPoint" src="/images/action-mark.png" />
        </div>
        <div class="battle-ground">
          <div class="space"></div>
          <div class="heroes">
            <img id="left_player" :src="srcLeftPlayer" style="height: 66px" />
            <img id="right_player" :src="srcRightPlayer" style="height: 66px" />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import io from "socket.io-client";

const socket = io(`${location.protocol}//${location.hostname}:3006`);

export default {
  name: "App",

  data() {
    return {
      status: "connecting...",
      message: "",
      toggleReadyButton: false,
      toggleJoinButton: true,
      toggleRematchButton: false,
      toggleExclamationPoint: false,
      gameLauched: false,
      srcLeftPlayer: "/images/kirby/kirby_start.png",
      srcRightPlayer: "/images/knight/knight_start.png",
    };
  },

  mounted() {
    socket.on("connect", () => {
      this.status = "connected";
      this.toggleJoinButton = true;
      this.gameLauched = false;
      this.toggleRematchButton = false;
    });

    socket.on("disconnect", () => {
      this.status = "disconnected";
      this.toggleJoinButton = false;
      this.toggleReadyButton = false;
      this.toggleExclamationPoint = false;
      this.gameLauched = false;
    });

    socket.on("player.joined", (player) => {
      this.status = "Joined as " + player.name;
      this.toggleReadyButton = true;
      this.toggleJoinButton = false;
    });

    socket.on("game.ready", (game) => {
      if (game.isFull === true) {
        this.gameLauched = true;
        setInterval(() => {
          if (this.gameLauched === true) this.toggleExclamationPoint = true;
        }, game.delay);
      }
    });

    socket.on("game.end", (player) => {
      this.gameLauched = false;
      this.message = player.name + " wins !";
      if (player.name === "Kirbee") {
        this.srcLeftPlayer = "/images/knight/knight_lose.png";
        this.srcRightPlayer = "/images/kirby/kirby_win.png";
      } else {
        this.srcLeftPlayer = "/images/knight/knight_win.png";
        this.srcRightPlayer = "/images/kirby/kirby_lose.png";
      }

      this.toggleRematchButton = true;
      this.toggleExclamationPoint = false;
    });

    socket.on("opponent.disconnected", () => {
      this.toggleExclamationPoint = false;
      this.gameLauched = false;
      this.toggleRematchButton = false;
      if (!this.toggleJoinButton && !this.toggleReadyButton)
        this.toggleReadyButton = true;
    });

    ["click", "keypress"].forEach((e) => {
      window.addEventListener(
        e,
        function () {
          if (this.gameLauched) {
            socket.emit("player.keypressed", { toggleExclamationPoint: this.toggleExclamationPoint} );
            this.toggleExclamationPoint = false;
          }
        }.bind(this)
      );
    });

    socket.on("error", (error) => {
      let errorMessage;
      switch (error.error) {
        case "TOO_MANY_PLAYERS":
          errorMessage =
            "You arrived too late, we already have two players. Try again later.";
          this.toggleJoinButton = false;
          break;
        case "ALREADY_JOIN":
          errorMessage = "Wait for a second player, you have already joined";
          this.toggleJoinButton = false;
          this.toggleReadyButton = true;
          break;
        default:
          errorMessage = "OOPS an unexpected error occured";
          break;
      }

      this.status = errorMessage;
    });
  },

  methods: {
    join() {
      socket.emit("player.join");
    },
    ready() {
      socket.emit("player.ready");
      this.toggleReadyButton = false;
    },
    rematch() {
      socket.emit("player.ready");
      this.toggleRematchButton = false;
      this.toggleExclamationPoint = false;
      this.message = "";
    },
  },
};
</script>

<style scoped>
.App {
  width: 100%;
  height: 100%;
  background: url(/images/background.png) center center;
  background-size: cover;
  display: flex;
  justify-content: center;
  align-items: center;
}

.game {
  width: 512px;
  max-width: 90%;
  height: 444px;
  max-height: 90%;
  background: url(/images/background.png) center center;
  box-shadow: 0 0 9px rgb(0 0 0 / 60%), 0 0 0 9999px rgb(255 255 255 / 40%);
  border-radius: 5px;
  overflow: hidden;
}

.messages {
  height: 40%;
}

.demo-scene {
  height: 100%;
  padding: 0.7rem;
  text-align: center;
  color: white;
}

.battle-ground .heroes {
  display: flex;
  justify-content: space-around;
}

.battle-ground .space {
  height: 66px;
}

.demo-scene p {
  margin-bottom: 2rem;
}
</style>